diff -Naur vendor-41.0.5/openssl-sys/src/handwritten/dh.rs vendor-41.0.7/openssl-sys/src/handwritten/dh.rs
--- vendor-41.0.5/openssl-sys/src/handwritten/dh.rs	1969-12-31 19:00:00.000000000 -0500
+++ vendor-41.0.7/openssl-sys/src/handwritten/dh.rs	1969-12-31 19:00:00.000000000 -0500
@@ -5,6 +5,7 @@
     pub fn DH_free(dh: *mut DH);
     pub fn DH_check(dh: *const DH, codes: *mut c_int) -> c_int;
 
+    #[cfg(not(libressl382))]
     pub fn DH_generate_parameters(
         prime_len: c_int,
         generator: c_int,
diff -Naur vendor-41.0.5/openssl-sys/src/handwritten/ec.rs vendor-41.0.7/openssl-sys/src/handwritten/ec.rs
--- vendor-41.0.5/openssl-sys/src/handwritten/ec.rs	1969-12-31 19:00:00.000000000 -0500
+++ vendor-41.0.7/openssl-sys/src/handwritten/ec.rs	1969-12-31 19:00:00.000000000 -0500
@@ -46,6 +46,8 @@
 
     pub fn EC_GROUP_set_asn1_flag(key: *mut EC_GROUP, flag: c_int);
 
+    pub fn EC_GROUP_get_asn1_flag(group: *const EC_GROUP) -> c_int;
+
     pub fn EC_GROUP_get_curve_GFp(
         group: *const EC_GROUP,
         p: *mut BIGNUM,
@@ -99,7 +101,7 @@
 
     pub fn EC_POINT_dup(p: *const EC_POINT, group: *const EC_GROUP) -> *mut EC_POINT;
 
-    #[cfg(ossl111)]
+    #[cfg(any(ossl111, boringssl, libressl350))]
     pub fn EC_POINT_get_affine_coordinates(
         group: *const EC_GROUP,
         p: *const EC_POINT,
@@ -150,6 +152,20 @@
         ctx: *mut BN_CTX,
     ) -> c_int;
 
+    pub fn EC_POINT_point2hex(
+        group: *const EC_GROUP,
+        p: *const EC_POINT,
+        form: point_conversion_form_t,
+        ctx: *mut BN_CTX,
+    ) -> *mut c_char;
+
+    pub fn EC_POINT_hex2point(
+        group: *const EC_GROUP,
+        s: *const c_char,
+        p: *mut EC_POINT,
+        ctx: *mut BN_CTX,
+    ) -> *mut EC_POINT;
+
     pub fn EC_POINT_add(
         group: *const EC_GROUP,
         r: *mut EC_POINT,
diff -Naur vendor-41.0.5/openssl-sys/src/handwritten/evp.rs vendor-41.0.7/openssl-sys/src/handwritten/evp.rs
--- vendor-41.0.5/openssl-sys/src/handwritten/evp.rs	1969-12-31 19:00:00.000000000 -0500
+++ vendor-41.0.7/openssl-sys/src/handwritten/evp.rs	1969-12-31 19:00:00.000000000 -0500
@@ -52,7 +52,7 @@
 }
 
 cfg_if! {
-    if #[cfg(ossl110)] {
+    if #[cfg(any(ossl110, libressl382))] {
         extern "C" {
             pub fn EVP_MD_CTX_new() -> *mut EVP_MD_CTX;
             pub fn EVP_MD_CTX_free(ctx: *mut EVP_MD_CTX);
@@ -271,6 +271,8 @@
 extern "C" {
     pub fn EVP_CIPHER_CTX_new() -> *mut EVP_CIPHER_CTX;
     pub fn EVP_CIPHER_CTX_free(ctx: *mut EVP_CIPHER_CTX);
+    pub fn EVP_CIPHER_CTX_copy(dst: *mut EVP_CIPHER_CTX, src: *const EVP_CIPHER_CTX) -> c_int;
+
     pub fn EVP_MD_CTX_copy_ex(dst: *mut EVP_MD_CTX, src: *const EVP_MD_CTX) -> c_int;
     #[cfg(ossl111)]
     pub fn EVP_MD_CTX_reset(ctx: *mut EVP_MD_CTX) -> c_int;
@@ -283,6 +285,7 @@
         ptr: *mut c_void,
     ) -> c_int;
     pub fn EVP_CIPHER_CTX_rand_key(ctx: *mut EVP_CIPHER_CTX, key: *mut c_uchar) -> c_int;
+    pub fn EVP_CIPHER_CTX_set_flags(ctx: *mut EVP_CIPHER_CTX, flags: c_int);
 
     pub fn EVP_md_null() -> *const EVP_MD;
     pub fn EVP_md5() -> *const EVP_MD;
@@ -291,13 +294,13 @@
     pub fn EVP_sha256() -> *const EVP_MD;
     pub fn EVP_sha384() -> *const EVP_MD;
     pub fn EVP_sha512() -> *const EVP_MD;
-    #[cfg(ossl111)]
+    #[cfg(any(ossl111, libressl380))]
     pub fn EVP_sha3_224() -> *const EVP_MD;
-    #[cfg(ossl111)]
+    #[cfg(any(ossl111, libressl380))]
     pub fn EVP_sha3_256() -> *const EVP_MD;
-    #[cfg(ossl111)]
+    #[cfg(any(ossl111, libressl380))]
     pub fn EVP_sha3_384() -> *const EVP_MD;
-    #[cfg(ossl111)]
+    #[cfg(any(ossl111, libressl380))]
     pub fn EVP_sha3_512() -> *const EVP_MD;
     #[cfg(ossl111)]
     pub fn EVP_shake128() -> *const EVP_MD;
@@ -309,7 +312,10 @@
     pub fn EVP_des_ecb() -> *const EVP_CIPHER;
     pub fn EVP_des_ede3() -> *const EVP_CIPHER;
     pub fn EVP_des_ede3_cbc() -> *const EVP_CIPHER;
+    pub fn EVP_des_ede3_ecb() -> *const EVP_CIPHER;
     pub fn EVP_des_ede3_cfb64() -> *const EVP_CIPHER;
+    pub fn EVP_des_ede3_cfb8() -> *const EVP_CIPHER;
+    pub fn EVP_des_ede3_ofb() -> *const EVP_CIPHER;
     pub fn EVP_des_cbc() -> *const EVP_CIPHER;
     #[cfg(not(osslconf = "OPENSSL_NO_RC4"))]
     pub fn EVP_rc4() -> *const EVP_CIPHER;
@@ -329,6 +335,10 @@
     pub fn EVP_aes_128_ofb() -> *const EVP_CIPHER;
     #[cfg(ossl110)]
     pub fn EVP_aes_128_ocb() -> *const EVP_CIPHER;
+    #[cfg(ossl102)]
+    pub fn EVP_aes_128_wrap() -> *const EVP_CIPHER;
+    #[cfg(ossl110)]
+    pub fn EVP_aes_128_wrap_pad() -> *const EVP_CIPHER;
     pub fn EVP_aes_192_ecb() -> *const EVP_CIPHER;
     pub fn EVP_aes_192_cbc() -> *const EVP_CIPHER;
     pub fn EVP_aes_192_cfb1() -> *const EVP_CIPHER;
@@ -340,6 +350,10 @@
     pub fn EVP_aes_192_ofb() -> *const EVP_CIPHER;
     #[cfg(ossl110)]
     pub fn EVP_aes_192_ocb() -> *const EVP_CIPHER;
+    #[cfg(ossl102)]
+    pub fn EVP_aes_192_wrap() -> *const EVP_CIPHER;
+    #[cfg(ossl110)]
+    pub fn EVP_aes_192_wrap_pad() -> *const EVP_CIPHER;
     pub fn EVP_aes_256_ecb() -> *const EVP_CIPHER;
     pub fn EVP_aes_256_cbc() -> *const EVP_CIPHER;
     pub fn EVP_aes_256_cfb1() -> *const EVP_CIPHER;
@@ -352,9 +366,13 @@
     pub fn EVP_aes_256_ofb() -> *const EVP_CIPHER;
     #[cfg(ossl110)]
     pub fn EVP_aes_256_ocb() -> *const EVP_CIPHER;
-    #[cfg(all(ossl110, not(osslconf = "OPENSSL_NO_CHACHA")))]
+    #[cfg(ossl102)]
+    pub fn EVP_aes_256_wrap() -> *const EVP_CIPHER;
+    #[cfg(ossl110)]
+    pub fn EVP_aes_256_wrap_pad() -> *const EVP_CIPHER;
+    #[cfg(all(any(ossl110, libressl310), not(osslconf = "OPENSSL_NO_CHACHA")))]
     pub fn EVP_chacha20() -> *const EVP_CIPHER;
-    #[cfg(all(ossl110, not(osslconf = "OPENSSL_NO_CHACHA")))]
+    #[cfg(all(any(ossl110, libressl360), not(osslconf = "OPENSSL_NO_CHACHA")))]
     pub fn EVP_chacha20_poly1305() -> *const EVP_CIPHER;
     #[cfg(not(osslconf = "OPENSSL_NO_SEED"))]
     pub fn EVP_seed_cbc() -> *const EVP_CIPHER;
@@ -376,28 +394,48 @@
     #[cfg(all(any(ossl111, libressl291), not(osslconf = "OPENSSL_NO_SM4")))]
     pub fn EVP_sm4_ctr() -> *const EVP_CIPHER;
 
-    #[cfg(not(any(boringssl, osslconf = "OPENSSL_NO_CAMELLIA")))]
+    #[cfg(not(osslconf = "OPENSSL_NO_CAMELLIA"))]
     pub fn EVP_camellia_128_cfb128() -> *const EVP_CIPHER;
-    #[cfg(not(any(boringssl, osslconf = "OPENSSL_NO_CAMELLIA")))]
+    #[cfg(not(osslconf = "OPENSSL_NO_CAMELLIA"))]
     pub fn EVP_camellia_128_ecb() -> *const EVP_CIPHER;
-    #[cfg(not(any(boringssl, osslconf = "OPENSSL_NO_CAMELLIA")))]
+    #[cfg(not(osslconf = "OPENSSL_NO_CAMELLIA"))]
+    pub fn EVP_camellia_128_cbc() -> *const EVP_CIPHER;
+    #[cfg(not(osslconf = "OPENSSL_NO_CAMELLIA"))]
+    pub fn EVP_camellia_128_ofb() -> *const EVP_CIPHER;
+    #[cfg(not(osslconf = "OPENSSL_NO_CAMELLIA"))]
     pub fn EVP_camellia_192_cfb128() -> *const EVP_CIPHER;
-    #[cfg(not(any(boringssl, osslconf = "OPENSSL_NO_CAMELLIA")))]
+    #[cfg(not(osslconf = "OPENSSL_NO_CAMELLIA"))]
     pub fn EVP_camellia_192_ecb() -> *const EVP_CIPHER;
-    #[cfg(not(any(boringssl, osslconf = "OPENSSL_NO_CAMELLIA")))]
+    #[cfg(not(osslconf = "OPENSSL_NO_CAMELLIA"))]
+    pub fn EVP_camellia_192_cbc() -> *const EVP_CIPHER;
+    #[cfg(not(osslconf = "OPENSSL_NO_CAMELLIA"))]
+    pub fn EVP_camellia_192_ofb() -> *const EVP_CIPHER;
+    #[cfg(not(osslconf = "OPENSSL_NO_CAMELLIA"))]
     pub fn EVP_camellia_256_cfb128() -> *const EVP_CIPHER;
-    #[cfg(not(any(boringssl, osslconf = "OPENSSL_NO_CAMELLIA")))]
+    #[cfg(not(osslconf = "OPENSSL_NO_CAMELLIA"))]
     pub fn EVP_camellia_256_ecb() -> *const EVP_CIPHER;
+    #[cfg(not(osslconf = "OPENSSL_NO_CAMELLIA"))]
+    pub fn EVP_camellia_256_cbc() -> *const EVP_CIPHER;
+    #[cfg(not(osslconf = "OPENSSL_NO_CAMELLIA"))]
+    pub fn EVP_camellia_256_ofb() -> *const EVP_CIPHER;
 
-    #[cfg(not(any(boringssl, osslconf = "OPENSSL_NO_CAST")))]
+    #[cfg(not(osslconf = "OPENSSL_NO_CAST"))]
     pub fn EVP_cast5_cfb64() -> *const EVP_CIPHER;
-    #[cfg(not(any(boringssl, osslconf = "OPENSSL_NO_CAST")))]
+    #[cfg(not(osslconf = "OPENSSL_NO_CAST"))]
     pub fn EVP_cast5_ecb() -> *const EVP_CIPHER;
+    #[cfg(not(osslconf = "OPENSSL_NO_CAST"))]
+    pub fn EVP_cast5_cbc() -> *const EVP_CIPHER;
+    #[cfg(not(osslconf = "OPENSSL_NO_CAST"))]
+    pub fn EVP_cast5_ofb() -> *const EVP_CIPHER;
 
-    #[cfg(not(any(boringssl, osslconf = "OPENSSL_NO_IDEA")))]
+    #[cfg(not(osslconf = "OPENSSL_NO_IDEA"))]
     pub fn EVP_idea_cfb64() -> *const EVP_CIPHER;
-    #[cfg(not(any(boringssl, osslconf = "OPENSSL_NO_IDEA")))]
+    #[cfg(not(osslconf = "OPENSSL_NO_IDEA"))]
     pub fn EVP_idea_ecb() -> *const EVP_CIPHER;
+    #[cfg(not(osslconf = "OPENSSL_NO_IDEA"))]
+    pub fn EVP_idea_cbc() -> *const EVP_CIPHER;
+    #[cfg(not(osslconf = "OPENSSL_NO_IDEA"))]
+    pub fn EVP_idea_ofb() -> *const EVP_CIPHER;
 
     #[cfg(not(ossl110))]
     pub fn OPENSSL_add_all_algorithms_noconf();
@@ -413,22 +451,6 @@
             pub fn EVP_PKEY_get_bits(key: *const EVP_PKEY) -> c_int;
             pub fn EVP_PKEY_get_security_bits(key: *const EVP_PKEY) -> c_int;
         }
-
-        #[inline]
-        pub unsafe fn EVP_PKEY_id(pkey: *const EVP_PKEY) -> c_int {
-            EVP_PKEY_get_id(pkey)
-        }
-
-        #[inline]
-        pub unsafe fn EVP_PKEY_bits(pkey: *const EVP_PKEY) -> c_int {
-            EVP_PKEY_get_bits(pkey)
-        }
-
-        #[inline]
-        pub unsafe fn EVP_PKEY_security_bits(pkey: *const EVP_PKEY) -> c_int {
-            EVP_PKEY_get_security_bits(pkey)
-        }
-
     } else {
         extern "C" {
             pub fn EVP_PKEY_id(pkey: *const EVP_PKEY) -> c_int;
@@ -513,6 +535,9 @@
         p2: *mut c_void,
     ) -> c_int;
 
+    #[cfg(ossl300)]
+    pub fn EVP_PKEY_CTX_set_signature_md(ctx: *mut EVP_PKEY_CTX, md: *const EVP_MD) -> c_int;
+
     pub fn EVP_PKEY_new_mac_key(
         type_: c_int,
         e: *mut ENGINE,
@@ -522,6 +547,12 @@
 
     pub fn EVP_PKEY_derive_init(ctx: *mut EVP_PKEY_CTX) -> c_int;
     pub fn EVP_PKEY_derive_set_peer(ctx: *mut EVP_PKEY_CTX, peer: *mut EVP_PKEY) -> c_int;
+    #[cfg(ossl300)]
+    pub fn EVP_PKEY_derive_set_peer_ex(
+        ctx: *mut EVP_PKEY_CTX,
+        peer: *mut EVP_PKEY,
+        validate_peer: c_int,
+    ) -> c_int;
     pub fn EVP_PKEY_derive(ctx: *mut EVP_PKEY_CTX, key: *mut c_uchar, size: *mut size_t) -> c_int;
 
     #[cfg(ossl300)]
@@ -566,6 +597,14 @@
         pin: *const c_uchar,
         pinlen: size_t,
     ) -> c_int;
+    pub fn EVP_PKEY_verify_recover_init(ctx: *mut EVP_PKEY_CTX) -> c_int;
+    pub fn EVP_PKEY_verify_recover(
+        ctx: *mut EVP_PKEY_CTX,
+        rout: *mut c_uchar,
+        routlen: *mut size_t,
+        sig: *const c_uchar,
+        siglen: size_t,
+    ) -> c_int;
 }
 
 const_ptr_api! {
diff -Naur vendor-41.0.5/openssl-sys/src/handwritten/mod.rs vendor-41.0.7/openssl-sys/src/handwritten/mod.rs
--- vendor-41.0.5/openssl-sys/src/handwritten/mod.rs	1969-12-31 19:00:00.000000000 -0500
+++ vendor-41.0.7/openssl-sys/src/handwritten/mod.rs	1969-12-31 19:00:00.000000000 -0500
@@ -18,6 +18,8 @@
 pub use self::pem::*;
 pub use self::pkcs12::*;
 pub use self::pkcs7::*;
+#[cfg(libressl)]
+pub use self::poly1305::*;
 pub use self::provider::*;
 pub use self::rand::*;
 pub use self::rsa::*;
@@ -52,6 +54,8 @@
 mod pem;
 mod pkcs12;
 mod pkcs7;
+#[cfg(libressl)]
+mod poly1305;
 mod provider;
 mod rand;
 mod rsa;
diff -Naur vendor-41.0.5/openssl-sys/src/handwritten/poly1305.rs vendor-41.0.7/openssl-sys/src/handwritten/poly1305.rs
--- vendor-41.0.5/openssl-sys/src/handwritten/poly1305.rs	1969-12-31 19:00:00.000000000 -0500
+++ vendor-41.0.7/openssl-sys/src/handwritten/poly1305.rs	1969-12-31 19:00:00.000000000 -0500
@@ -0,0 +1,23 @@
+use super::super::*;
+use libc::*;
+
+cfg_if! {
+    if #[cfg(libressl)] {
+        #[repr(C)]
+        #[derive(Debug, Copy, Clone)]
+        pub struct poly1305_context {
+            pub aligner: usize,
+            pub opaque: [::libc::c_uchar; 136usize],
+        }
+        pub type poly1305_state = poly1305_context;
+        extern "C" {
+            pub fn CRYPTO_poly1305_init(ctx: *mut poly1305_context, key: *const ::libc::c_uchar);
+            pub fn CRYPTO_poly1305_update(
+                ctx: *mut poly1305_context,
+                in_: *const ::libc::c_uchar,
+                len: usize,
+            );
+            pub fn CRYPTO_poly1305_finish(ctx: *mut poly1305_context, mac: *mut ::libc::c_uchar);
+        }
+    }
+}
diff -Naur vendor-41.0.5/openssl-sys/src/handwritten/ssl.rs vendor-41.0.7/openssl-sys/src/handwritten/ssl.rs
--- vendor-41.0.5/openssl-sys/src/handwritten/ssl.rs	1969-12-31 19:00:00.000000000 -0500
+++ vendor-41.0.7/openssl-sys/src/handwritten/ssl.rs	1969-12-31 19:00:00.000000000 -0500
@@ -924,3 +924,17 @@
     #[cfg(all(ossl111, not(ossl111b)))]
     pub fn SSL_get_num_tickets(s: *mut SSL) -> size_t;
 }
+
+extern "C" {
+    #[cfg(any(ossl110, libressl360))]
+    pub fn SSL_CTX_set_security_level(ctx: *mut SSL_CTX, level: c_int);
+
+    #[cfg(any(ossl110, libressl360))]
+    pub fn SSL_set_security_level(s: *mut SSL, level: c_int);
+
+    #[cfg(any(ossl110, libressl360))]
+    pub fn SSL_CTX_get_security_level(ctx: *const SSL_CTX) -> c_int;
+
+    #[cfg(any(ossl110, libressl360))]
+    pub fn SSL_get_security_level(s: *const SSL) -> c_int;
+}
diff -Naur vendor-41.0.5/openssl-sys/src/handwritten/types.rs vendor-41.0.7/openssl-sys/src/handwritten/types.rs
--- vendor-41.0.5/openssl-sys/src/handwritten/types.rs	1969-12-31 19:00:00.000000000 -0500
+++ vendor-41.0.7/openssl-sys/src/handwritten/types.rs	1969-12-31 19:00:00.000000000 -0500
@@ -329,7 +329,7 @@
     }
 }
 cfg_if! {
-    if #[cfg(ossl110)] {
+    if #[cfg(any(ossl110, libressl382))] {
         pub enum X509_ALGOR {}
     } else {
         #[repr(C)]
diff -Naur vendor-41.0.5/openssl-sys/src/handwritten/x509.rs vendor-41.0.7/openssl-sys/src/handwritten/x509.rs
--- vendor-41.0.5/openssl-sys/src/handwritten/x509.rs	1969-12-31 19:00:00.000000000 -0500
+++ vendor-41.0.7/openssl-sys/src/handwritten/x509.rs	1969-12-31 19:00:00.000000000 -0500
@@ -644,6 +644,8 @@
     extern "C" {
         #[cfg(any(ossl110, libressl270))]
         pub fn X509_STORE_get0_objects(ctx: #[const_ptr_if(ossl300)] X509_STORE) -> *mut stack_st_X509_OBJECT;
+        #[cfg(ossl300)]
+        pub fn X509_STORE_get1_all_certs(ctx: *mut X509_STORE) -> *mut stack_st_X509;
     }
 }
 
diff -Naur vendor-41.0.5/openssl-sys/src/handwritten/x509v3.rs vendor-41.0.7/openssl-sys/src/handwritten/x509v3.rs
--- vendor-41.0.5/openssl-sys/src/handwritten/x509v3.rs	1969-12-31 19:00:00.000000000 -0500
+++ vendor-41.0.7/openssl-sys/src/handwritten/x509v3.rs	1969-12-31 19:00:00.000000000 -0500
@@ -145,3 +145,22 @@
     pub fn DIST_POINT_free(dist_point: *mut DIST_POINT);
     pub fn DIST_POINT_NAME_free(dist_point: *mut DIST_POINT_NAME);
 }
+
+#[cfg(ossl102)]
+extern "C" {
+    pub fn X509_check_host(
+        x: *mut X509,
+        chk: *const c_char,
+        chklen: usize,
+        flags: c_uint,
+        peername: *mut *mut c_char,
+    ) -> c_int;
+    pub fn X509_check_email(
+        x: *mut X509,
+        chk: *const c_char,
+        chklen: usize,
+        flags: c_uint,
+    ) -> c_int;
+    pub fn X509_check_ip(x: *mut X509, chk: *const c_uchar, chklen: usize, flags: c_uint) -> c_int;
+    pub fn X509_check_ip_asc(x: *mut X509, ipasc: *const c_char, flags: c_uint) -> c_int;
+}
diff -Naur vendor-41.0.5/openssl-sys/src/handwritten/x509_vfy.rs vendor-41.0.7/openssl-sys/src/handwritten/x509_vfy.rs
--- vendor-41.0.5/openssl-sys/src/handwritten/x509_vfy.rs	1969-12-31 19:00:00.000000000 -0500
+++ vendor-41.0.7/openssl-sys/src/handwritten/x509_vfy.rs	1969-12-31 19:00:00.000000000 -0500
@@ -118,6 +118,12 @@
     #[cfg(any(ossl102, libressl261))]
     pub fn X509_VERIFY_PARAM_set_hostflags(param: *mut X509_VERIFY_PARAM, flags: c_uint);
     #[cfg(any(ossl102, libressl261))]
+    pub fn X509_VERIFY_PARAM_set1_email(
+        param: *mut X509_VERIFY_PARAM,
+        email: *const c_char,
+        emaillen: size_t,
+    ) -> c_int;
+    #[cfg(any(ossl102, libressl261))]
     pub fn X509_VERIFY_PARAM_set1_ip(
         param: *mut X509_VERIFY_PARAM,
         ip: *const c_uchar,
diff -Naur vendor-41.0.5/openssl-sys/src/lib.rs vendor-41.0.7/openssl-sys/src/lib.rs
--- vendor-41.0.5/openssl-sys/src/lib.rs	1969-12-31 19:00:00.000000000 -0500
+++ vendor-41.0.7/openssl-sys/src/lib.rs	1969-12-31 19:00:00.000000000 -0500
@@ -1,20 +1,17 @@
 #![allow(
     clippy::missing_safety_doc,
-    clippy::unreadable_literal,
-    clippy::uninlined_format_args,
-    clippy::upper_case_acronyms,
     dead_code,
     non_camel_case_types,
     non_snake_case,
     non_upper_case_globals,
-    overflowing_literals,
     unused_imports
 )]
+#![cfg_attr(feature = "unstable_boringssl", allow(ambiguous_glob_reexports))]
 #![doc(html_root_url = "https://docs.rs/openssl-sys/0.9")]
 #![recursion_limit = "128"] // configure fixed limit across all rust versions
 
 extern crate libc;
-pub use libc::*;
+pub use libc::c_int;
 
 #[cfg(feature = "unstable_boringssl")]
 extern crate bssl_sys;
diff -Naur vendor-41.0.5/openssl-sys/src/obj_mac.rs vendor-41.0.7/openssl-sys/src/obj_mac.rs
--- vendor-41.0.5/openssl-sys/src/obj_mac.rs	1969-12-31 19:00:00.000000000 -0500
+++ vendor-41.0.7/openssl-sys/src/obj_mac.rs	1969-12-31 19:00:00.000000000 -0500
@@ -135,6 +135,8 @@
 pub const NID_sha224WithRSAEncryption: c_int = 671;
 pub const NID_pkcs3: c_int = 27;
 pub const NID_dhKeyAgreement: c_int = 28;
+#[cfg(ossl110)]
+pub const NID_dhpublicnumber: c_int = 920;
 pub const NID_pkcs5: c_int = 187;
 pub const NID_pbeWithMD2AndDES_CBC: c_int = 9;
 pub const NID_pbeWithMD5AndDES_CBC: c_int = 10;
@@ -926,6 +928,8 @@
 pub const NID_X448: c_int = 1035;
 #[cfg(ossl110)]
 pub const NID_hkdf: c_int = 1036;
+#[cfg(libressl360)]
+pub const NID_hkdf: c_int = 1022;
 #[cfg(ossl111)]
 pub const NID_poly1305: c_int = 1061;
 #[cfg(ossl111)]
@@ -935,6 +939,8 @@
 #[cfg(ossl111)]
 pub const NID_ED448: c_int = 1088;
 #[cfg(ossl111)]
+pub const NID_sm2: c_int = 1172;
+#[cfg(ossl111)]
 pub const NID_sm3: c_int = 1143;
 #[cfg(libressl291)]
 pub const NID_sm3: c_int = 968;
@@ -972,13 +978,25 @@
 pub const NID_sm4_ctr: c_int = 979;
 #[cfg(ossl111)]
 pub const NID_sha3_224: c_int = 1096;
+#[cfg(libressl380)]
+pub const NID_sha3_224: c_int = 1031;
 #[cfg(ossl111)]
 pub const NID_sha3_256: c_int = 1097;
+#[cfg(libressl380)]
+pub const NID_sha3_256: c_int = 1032;
 #[cfg(ossl111)]
 pub const NID_sha3_384: c_int = 1098;
+#[cfg(libressl380)]
+pub const NID_sha3_384: c_int = 1033;
 #[cfg(ossl111)]
 pub const NID_sha3_512: c_int = 1099;
+#[cfg(libressl380)]
+pub const NID_sha3_512: c_int = 1034;
 #[cfg(ossl111)]
 pub const NID_shake128: c_int = 1100;
 #[cfg(ossl111)]
 pub const NID_shake256: c_int = 1101;
+#[cfg(ossl110)]
+pub const NID_chacha20_poly1305: c_int = 1018;
+#[cfg(libressl271)]
+pub const NID_chacha20_poly1305: c_int = 967;
diff -Naur vendor-41.0.5/openssl-sys/src/rsa.rs vendor-41.0.7/openssl-sys/src/rsa.rs
--- vendor-41.0.5/openssl-sys/src/rsa.rs	1969-12-31 19:00:00.000000000 -0500
+++ vendor-41.0.7/openssl-sys/src/rsa.rs	1969-12-31 19:00:00.000000000 -0500
@@ -76,7 +76,7 @@
         EVP_PKEY_OP_TYPE_CRYPT,
         EVP_PKEY_CTRL_RSA_OAEP_LABEL,
         len,
-        label as *mut c_void,
+        label,
     )
 }
 
diff -Naur vendor-41.0.5/openssl-sys/src/ssl.rs vendor-41.0.7/openssl-sys/src/ssl.rs
--- vendor-41.0.5/openssl-sys/src/ssl.rs	1969-12-31 19:00:00.000000000 -0500
+++ vendor-41.0.7/openssl-sys/src/ssl.rs	1969-12-31 19:00:00.000000000 -0500
@@ -349,6 +349,8 @@
 pub const SSL_CTRL_SET_SIGALGS_LIST: c_int = 98;
 #[cfg(ossl102)]
 pub const SSL_CTRL_SET_VERIFY_CERT_STORE: c_int = 106;
+#[cfg(ossl300)]
+pub const SSL_CTRL_GET_PEER_TMP_KEY: c_int = 109;
 #[cfg(ossl110)]
 pub const SSL_CTRL_GET_EXTMS_SUPPORT: c_int = 122;
 #[cfg(any(ossl110, libressl261))]
@@ -359,6 +361,8 @@
 pub const SSL_CTRL_GET_MIN_PROTO_VERSION: c_int = 130;
 #[cfg(any(ossl110g, libressl270))]
 pub const SSL_CTRL_GET_MAX_PROTO_VERSION: c_int = 131;
+#[cfg(ossl300)]
+pub const SSL_CTRL_GET_TMP_KEY: c_int = 133;
 
 pub unsafe fn SSL_CTX_set_tmp_dh(ctx: *mut SSL_CTX, dh: *mut DH) -> c_long {
     SSL_CTX_ctrl(ctx, SSL_CTRL_SET_TMP_DH, 0, dh as *mut c_void)
@@ -506,6 +510,17 @@
         }
     }
 }
+cfg_if! {
+    if #[cfg(ossl300)] {
+        pub unsafe fn SSL_get_peer_tmp_key(ssl: *mut SSL, key: *mut *mut EVP_PKEY) -> c_long {
+            SSL_ctrl(ssl, SSL_CTRL_GET_PEER_TMP_KEY, 0, key as *mut c_void)
+        }
+
+        pub unsafe fn SSL_get_tmp_key(ssl: *mut SSL, key: *mut *mut EVP_PKEY) -> c_long {
+            SSL_ctrl(ssl, SSL_CTRL_GET_TMP_KEY, 0, key as *mut c_void)
+        }
+    }
+}
 
 #[cfg(ossl111)]
 pub const SSL_CLIENT_HELLO_SUCCESS: c_int = 1;
diff -Naur vendor-41.0.5/openssl-sys/src/x509v3.rs vendor-41.0.7/openssl-sys/src/x509v3.rs
--- vendor-41.0.5/openssl-sys/src/x509v3.rs	1969-12-31 19:00:00.000000000 -0500
+++ vendor-41.0.7/openssl-sys/src/x509v3.rs	1969-12-31 19:00:00.000000000 -0500
@@ -89,8 +89,16 @@
 pub const X509_PURPOSE_ANY: c_int = 7;
 pub const X509_PURPOSE_OCSP_HELPER: c_int = 8;
 pub const X509_PURPOSE_TIMESTAMP_SIGN: c_int = 9;
+#[cfg(ossl320)]
+pub const X509_PURPOSE_CODE_SIGN: c_int = 10;
 pub const X509_PURPOSE_MIN: c_int = 1;
-pub const X509_PURPOSE_MAX: c_int = 9;
+cfg_if! {
+    if #[cfg(ossl320)] {
+        pub const X509_PURPOSE_MAX: c_int = 10;
+    } else {
+        pub const X509_PURPOSE_MAX: c_int = 9;
+    }
+}
 
 pub const CRL_REASON_UNSPECIFIED: c_int = 0;
 pub const CRL_REASON_KEY_COMPROMISE: c_int = 1;
